# PyTorchWrapper

PyTorchWrapper is a library that provides a systematic and extensible way to build, train, evaluate, and tune deep learning models
using PyTorch. It also provides several ready to use modules and functions for fast model development.

## Installation

### From PyPI
```bash
pip install pytorch-wrapper
```

### From Source

```bash
git clone https://github.com/jkoutsikakis/pytorch-wrapper.git
cd pytorch-wrapper
pip install .
```

## Docs & Examples

The docs can be found [here](https://pytorch-wrapper.readthedocs.io/en/latest/).

There are also the following examples in notebook format:

1. [Two Spiral Task](examples/1_two_spiral_task.ipynb)
2. [Image Classification Task](examples/2_image_classification_task.ipynb)
3. [Tuning Image Classifier](examples/3_tuning_image_classifier.ipynb)
4. [Text Classification Task](examples/4_text_classification_task.ipynb)
5. [Sequence Classification Task](examples/5_sequence_classification_task.ipynb)
6. [Custom Callback](examples/6_custom_callback.ipynb)
7. [Custom Loss Wrapper](examples/7_custom_loss_wrapper.ipynb)
8. [Custom Evaluator](examples/8_custom_evaluator.ipynb)
